## cron 3.0pl1

=== Makefile ===
#/* Copyright 1988,1990,1993,1994 by Paul Vixie
# * All rights reserved
# *
# * Distribute freely, except: don't remove my name from the source or
# * documentation (don't take credit for my work), mark your changes (don't
# * get me blamed for your possible bugs), don't alter or remove this
# * notice.  May be sold if buildable source is provided to buyer.  No
# * warrantee of any kind, express or implied, is included with this
# * software; use at your own risk, responsibility for damages (if any) to
# * anyone resulting from the use of this software rests entirely with the
# * user.
# *
# * Send bug reports, bug fixes, enhancements, requests, flames, etc., and
# * I'll try to keep a version up to date.  I can be reached as follows:
# * Paul Vixie          <paul@vix.com>          uunet!decwrl!vixie!paul
# */

# Makefile for vixie's cron
#
# $Id: Makefile,v 2.9 1994/01/15 20:43:43 vixie Exp $
#
# vix 03mar88 [moved to RCS, rest of log is in there]
# vix 30mar87 [goodbye, time.c; hello, getopt]
# vix 12feb87 [cleanup for distribution]
# vix 30dec86 [written]

# NOTES:
#	'make' can be done by anyone
#	'make install' must be done by root
#
#	this package needs getopt(3), bitstring(3), and BSD install(8).
#
#	the configurable stuff in this makefile consists of compilation
#	options (use -O, cron runs forever) and destination directories.
#	SHELL is for the 'augumented make' systems where 'make' imports
#	SHELL from the environment and then uses it to run its commands.
#	if your environment SHELL variable is /bin/csh, make goes real
#	slow and sometimes does the wrong thing.  
#
#	this package needs the 'bitstring macros' library, which is
#	available from me or from the comp.sources.unix archive.  if you
#	put 'bitstring.h' in a non-standard place (i.e., not intuited by
#	cc(1)), you will have to define INCLUDE to set the include
#	directory for cc.  INCLUDE should be `-Isomethingorother'.
#
#	there's more configuration info in config.h; edit that first!

#################################### begin configurable stuff
#<<DESTROOT is assumed to have ./etc, ./bin, and ./man subdirectories>>
DESTROOT	=	$(DESTDIR)/usr
DESTSBIN	=	$(DESTROOT)/sbin
DESTBIN		=	$(DESTROOT)/bin
DESTMAN		=	$(DESTROOT)/share/man
#<<need bitstring.h>>
INCLUDE		=	-I.
#INCLUDE	=
#<<need getopt()>>
LIBS		=
#<<optimize or debug?>>
#OPTIM		=	-O
OPTIM		=	-g
#<<ATT or BSD or POSIX?>>
# (ATT untested)
#COMPAT		=	-DATT
#(BSD is only needed if <sys/params.h> does not define it, as on ULTRIX)
#COMPAT		=	-DBSD
# (POSIX)
#COMPAT		=	-DPOSIX
#<<lint flags of choice?>>
LINTFLAGS	=	-hbxa $(INCLUDE) $(COMPAT) $(DEBUGGING)
#<<want to use a nonstandard CC?>>
#CC		=	vcc
#<<manifest defines>>
DEFS		=
#(SGI IRIX systems need this)
#DEFS		=	-D_BSD_SIGNALS -Dconst=
#<<the name of the BSD-like install program>>
#INSTALL = installbsd
INSTALL = install
#<<any special load flags>>
LDFLAGS		=
#################################### end configurable stuff

SHELL		=	/bin/sh
CFLAGS		=	$(OPTIM) $(INCLUDE) $(COMPAT) $(DEFS)

INFOS		=	README CHANGES FEATURES INSTALL CONVERSION THANKS MAIL
MANPAGES	=	bitstring.3 crontab.5 crontab.1 cron.8 putman.sh
HEADERS		=	bitstring.h cron.h config.h pathnames.h \
			externs.h compat.h
SOURCES		=	cron.c crontab.c database.c do_command.c entry.c \
			env.c job.c user.c popen.c misc.c compat.c
SHAR_SOURCE	=	$(INFOS) $(MANPAGES) Makefile $(HEADERS) $(SOURCES)
LINT_CRON	=	cron.c database.c user.c entry.c compat.c \
			misc.c job.c do_command.c env.c popen.c
LINT_CRONTAB	=	crontab.c misc.c entry.c env.c compat.c
CRON_OBJ	=	cron.o database.o user.o entry.o job.o do_command.o \
			misc.o env.o popen.o compat.o
CRONTAB_OBJ	=	crontab.o misc.o entry.o env.o compat.o

all		:	cron crontab

lint		:
			lint $(LINTFLAGS) $(LINT_CRON) $(LIBS) \
			|grep -v "constant argument to NOT" 2>&1
			lint $(LINTFLAGS) $(LINT_CRONTAB) $(LIBS) \
			|grep -v "constant argument to NOT" 2>&1

cron		:	$(CRON_OBJ)
			$(CC) $(LDFLAGS) -o cron $(CRON_OBJ) $(LIBS)

crontab		:	$(CRONTAB_OBJ)
			$(CC) $(LDFLAGS) -o crontab $(CRONTAB_OBJ) $(LIBS)

install		:	all
			$(INSTALL) -c -m  111 -o root -s cron    $(DESTSBIN)/
			$(INSTALL) -c -m 4111 -o root -s crontab $(DESTBIN)/
			sh putman.sh crontab.1 $(DESTMAN)
			sh putman.sh cron.8    $(DESTMAN)
			sh putman.sh crontab.5 $(DESTMAN)

clean		:;	rm -f *.o cron crontab a.out core tags *~ #*

kit		:	$(SHAR_SOURCE)
			makekit -m -s99k $(SHAR_SOURCE)

$(CRON_OBJ)	:	cron.h compat.h config.h externs.h pathnames.h Makefile
$(CRONTAB_OBJ)	:	cron.h compat.h config.h externs.h pathnames.h Makefile

=== debian/changelog ===
cron (3.0pl1-184ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 00:06:27 +0000

cron (3.0pl1-184ubuntu1) noble; urgency=medium

  * Merge with Debian unstable (LP: #2055105). Remaining changes:
    - debian/control: Move MTA to Suggests field.
    - debian/cron.default: change to a deprecated message to make it clear
      that the file is no longer in use.
    - d/p/f/inherit-path.patch: Add -P option to inherit PATH from environment,
      thanks to Tom Jones for the patch
    - Inherit PATH by default:
      + debian/crontab.main: Stop setting PATH
      + debian/cron.service, debian/cron.init: Pass -P to cron

 -- Vladimir Petko <vladimir.petko@canonical.com>  Tue, 27 Feb 2024 15:25:23 +1300

cron (3.0pl1-184) unstable; urgency=medium

  * created a new file /etc/supercat/spcrc-crontab-light for light
    backgrounds, and modified /etc/supercat/spcrc-crontab for dark
    backgrounds. Closes: #1061164
  * demoted supercat from Recommends: to Suggests:. Closes: #1061196

 -- Georges Khaznadar <georgesk@debian.org>  Sun, 21 Jan 2024 12:10:45 +0100

cron (3.0pl1-183) unstable; urgency=medium

  * deleted the patch features/Coloring_the_ouput_of_crontab_l.patch,
    enhanced the patch docs/more_examples_for_crontab.patch, added
    the file spcrc-crontab and recommended the package supercat, to
    give an opportunity to colorize the output of `crontab -l`, while
    keeping this output accessible. Closes: #1059828

 -- Georges Khaznadar <georgesk@debian.org>  Thu, 18 Jan 2024 09:51:30 +0100

cron (3.0pl1-182) unstable; urgency=medium

  * patched crontab.5 to document the possible use of leading zeroes,
    in order to line up columns. Closes: #946382

 -- Georges Khaznadar <georgesk@debian.org>  Mon, 25 Dec 2023 19:13:06 +0100

cron (3.0pl1-181) unstable; urgency=medium

  * patched crontab.5 in order to give useful information about using eval
    command, which makes easier to express environment assignments inside
    commands to call with cron. Closes: #773513. Closes: #876975

 -- Georges Khaznadar <georgesk@debian.org>  Sat, 16 Dec 2023 17:15:15 +0100

cron (3.0pl1-180) unstable; urgency=medium

  * implemented a new feature: when a command outputs very long lines,
    the message reporting them has wrapped lines. Closes: #777584
    + added a new test for autopkgtests.
  * renamed a test file to please lintian, which issued a warning

 -- Georges Khaznadar <georgesk@debian.org>  Wed, 22 Nov 2023 17:10:27 +0100

cron (3.0pl1-179) unstable; urgency=medium

  * improved crontab.c: it now emits a COLOR_RESET escape sequence before
    sending '\n' to ttys. Closes: #1055197

 -- Georges Khaznadar <georgesk@debian.org>  Sun, 12 Nov 2023 20:11:18 +0100

cron (3.0pl1-178ubuntu1) noble; urgency=medium

  * Merge with Debian unstable (LP: #2044015). Remaining changes:
    - debian/control: Move MTA to Suggests field.
    - debian/cron.default: change to a deprecated message to make it clear
      that the file is no longer in use.
    - d/p/f/inherit-path.patch: Add -P option to inherit PATH from environment,
      thanks to Tom Jones for the patch
    - Inherit PATH by default:
      + debian/crontab.main: Stop setting PATH
      + debian/cron.service, debian/cron.init: Pass -P to cron
  * Drop changes:
    - debian/tests/compare-with-old-cron-files: Compare against cron package
      shipped in Ubuntu Jammy instead of that shipped in Debian Bullseye
      [ Test removed in 3.0pl1-167 ]

 -- Vladimir Petko <vladimir.petko@canonical.com>  Tue, 21 Nov 2023 08:38:28 +1300

cron (3.0pl1-178) unstable; urgency=medium

  * checked that debian/crontab.main keeps /bin and /sbin in the PATH.
    Closes: #1051138
  * modified crontab.c, so `crontab -l` emits a COLOR_RESET escape sequence
    to a tty unconditionaly at the end of the lines, to prevent prompt
    corruption later. Closes: #1054327

 -- Georges Khaznadar <georgesk@debian.org>  Wed, 01 Nov 2023 17:56:35 +0100

cron (3.0pl1-177) unstable; urgency=medium

  * Included Alexander Schwinn's PR: this is about checking steps in crontabs,
    to prevent insane divisions, like dividing one hour in more than 60 steps
    for example
  * added a new test 'step_size_out_of_bound' to check the previous change
  * modified the fake editor debian/tests/cronfiller.py so it can take in
    account an environment variable LINES to append some lines to a
    crontab file.
  * made a longer sleep (now 4 seconds) in the test
    'check-messages-sent-by-cron' to prevent random failures due to a
    heavily loaded host

 -- Georges Khaznadar <georgesk@debian.org>  Thu, 19 Oct 2023 18:41:20 +0200

cron (3.0pl1-176) unstable; urgency=medium

  * added the switch -n in the synopsis line of cron.8
  * enable debug by default (it must still be triggered by -x when
    calling cron); enabled the -N switch when DEBUGGING is enabled for
    cron.
  * documented the -x switch in cron.8
  * declared myself as maintainer
  * made a roud trip with `gbp pq import/export`, which modifies the
    debian patches (adding some information, like for example a summary
    for every modified file)
  * modified the patch features/Coloring_the_ouput_of_crontab_l.patch
    in order to touch the background color when the foregroud color is
    changed, and keep an acceptable contrast. Closes: #1053288
  * added SyslogFacility=cron in the file cron.service. Closes: #1051619

 -- Georges Khaznadar <georgesk@debian.org>  Tue, 10 Oct 2023 19:45:44 +0200

cron (3.0pl1-175) unstable; urgency=medium

  * removed the line SHELL=/usr/bin/sh from an example in crontab.5; this,
    Closes: #166533
  * according to Message-ID: <87il8y5n5c.8.fsf@jidanni.org> sent to
    915289-done@bugs.debian.org, this bug should be closed now ??
    Closes: #915289 anyway.
  * uncommented EXTRA_OPTS="" in debian/cron.default; Closes: #1050702

 -- Georges Khaznadar <georgesk@debian.org>  Sun, 03 Sep 2023 12:30:35 +0200



=== debian/control ===
Source: cron
Section: admin
Priority: important
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Georges Khaznadar <georgesk@debian.org>
Standards-Version: 4.6.2
Build-Depends:
    debhelper-compat (= 13),
    libpam0g-dev,
    libselinux1-dev [linux-any],
    libaudit-dev [linux-any],
    python3:any
Rules-Requires-Root: no
Homepage: https://ftp.isc.org/isc/cron/
Vcs-Git: https://salsa.debian.org/debian/cron.git
Vcs-Browser: https://salsa.debian.org/debian/cron

Package: cron
Architecture: any
Multi-Arch: foreign
Pre-Depends:
    ${misc:Pre-Depends},
    cron-daemon-common
Depends:
    ${shlibs:Depends},
    ${misc:Depends},
    sensible-utils,
    libpam-runtime
Suggests:
    anacron,
    logrotate,
    checksecurity,
    supercat,
    default-mta | mail-transport-agent
Conflicts:
    systemd-cron,
    bcron,
    cronie
Replaces:
    systemd-cron,
    bcron,
    cronie
Provides: cron-daemon
Description: process scheduling daemon
 The cron daemon is a background process that runs particular programs at
 particular times (for example, every minute, day, week, or month), as
 specified in a crontab. By default, users may also create crontabs of
 their own so that processes are run on their behalf.
 .
 Output from the commands is usually mailed to the system administrator
 (or to the user in question); you should probably install a mail system
 as well so that you can receive these messages.
 .
 This cron package does not provide any system maintenance tasks. Basic
 periodic maintenance tasks are provided by other packages, such
 as checksecurity.

Package: cron-daemon-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
    adduser
Conflicts:
	cron (<< 3.0pl1-140),
	cronie (<< 1.6.1-5),
	systemd-cron(<< 1.15.18-1.1),
	bcron (<< 0.11-9.1)
Breaks:
    systemd-cron(<<1.15.19-5~)
Replaces:
	cron (<< 3.0pl1-140),
	cronie (<< 1.6.1-5),
	systemd-cron(<< 1.15.18-1.1),
	bcron (<< 0.11-9.1)
Description: process scheduling daemon's configuration files
 The cron daemon is a background process that runs particular programs at
 particular times (for example, every minute, day, week, or month), as
 specified in a crontab. By default, users may also create crontabs of
 their own so that processes are run on their behalf.
 .
 This package provides configuration files which must be there to
 define scheduled process sets.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# The package build supports three optional features. To enable/disable them,
# modify DEB_BUILD_OPTIONS accordingly:
#  * PAM support        default: ON     disable: DEB_BUILD_OPTIONS=nopam
#  * SELinux support    default: ON     disable: DEB_BUILD_OPTIONS=noselinux
#  * audit support      default: OFF    enable:  DEB_BUILD_OPTIONS=withaudit
#
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Retrieve architecture-related variables
include /usr/share/dpkg/architecture.mk

# Enable cross-compiling support
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
export CC=$(DEB_HOST_GNU_TYPE)-gcc
endif

# Customize build flags
export DEB_CFLAGS_MAINT_APPEND += -Wall -Wno-unused -Wno-comment
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# debug is enabled by default
ifneq (,$(findstring nodebug,$(DEB_BUILD_OPTIONS)))
  DEBUG_DEFS = -DDEBUGGING=0
else
  DEBUG_DEFS = -DDEBUGGING=1
endif
export DEBUG_DEFS

# PAM is enabled by default
ifeq (,$(findstring nopam,$(DEB_BUILD_OPTIONS)))
    PAM_DEFS = -DUSE_PAM
    PAM_LIBS = -lpam
    export PAM_DEFS PAM_LIBS
endif

# SELinux and audit are only available on Linux
ifeq ($(DEB_HOST_ARCH_OS), linux)
# SELinux is enabled by default
ifeq (,$(findstring noselinux,$(DEB_BUILD_OPTIONS)))
    SELINUX_DEFS = -DWITH_SELINUX
    SELINUX_LIBS = -lselinux
    export SELINUX_DEFS SELINUX_LIBS
endif

# audit is disabled by default
ifneq (,$(findstring withaudit,$(DEB_BUILD_OPTIONS)))
    AUDIT_DEFS = -DWITH_AUDIT
    AUDIT_LIBS = -laudit
    export AUDIT_DEFS AUDIT_LIBS
endif
endif # Linux


%:
	dh $@

override_dh_auto_install:
	# Empty target to bypass the auto-detected install target in Makefile
	#
	# this step is automatic with DebHelper >= 14
	dh_installsysusers

COMMON_ETC = debian/cron-daemon-common/etc
# beginning with release 3.0pl1-139, the configuration files
# are managed by the package cron-daemon-common

override_dh_install-indep:
	install -m 644 debian/crontab.main $(COMMON_ETC)/crontab
	install -m 644 debian/placeholder $(COMMON_ETC)/cron.d/.placeholder
	install -m 644 debian/placeholder $(COMMON_ETC)/cron.hourly/.placeholder
	install -m 644 debian/placeholder $(COMMON_ETC)/cron.daily/.placeholder
	install -m 644 debian/placeholder $(COMMON_ETC)/cron.weekly/.placeholder
	install -m 644 debian/placeholder $(COMMON_ETC)/cron.monthly/.placeholder
	install -m 644 debian/placeholder $(COMMON_ETC)/cron.yearly/.placeholder

=== debian/tests/control ===
Tests: check-significant-header,
 sanity-checks,
 check-messages-sent-by-cron,
 check-listings-protection,
 step-size-out-of-bound,
 check-wrapping-long-lines,
Depends: apt, binutils, exim4, mailutils, rsyslog, bsdextrautils, expect, @
Restrictions: needs-root, needs-internet, breaks-testbed

=== debian/watch ===
version=4

# GitLab hosted projects.
opts="uversionmangle=s/-\d*$//,filenamemangle=s%([^-]*-\d*)*%@PACKAGE@-$1%" \
    https://salsa.debian.org/debian/cron/-/tags \
    archive/debian/@ANY_VERSION@/cron-debian-\d\S*@ARCHIVE_EXT@

## cron 3.0pl1-105

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1




CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.

	touch configure-stamp


build: build-stamp

build-stamp: configure-stamp 
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE)
	#docbook-to-man debian/cron.sgml > cron.1

	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	-$(MAKE) clean

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	# Add here commands to install the package into debian/cron.
	$(MAKE) DESTDIR=$(CURDIR)/debian/cron install


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs CHANGES
	dh_installdocs
	dh_installexamples
#	dh_install
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_python
	dh_installinit
	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## cron 3.0pl1-106

=== Makefile ===
--- 
+++ 
@@ -51,34 +51,40 @@
 DESTSBIN	=	$(DESTROOT)/sbin
 DESTBIN		=	$(DESTROOT)/bin
 DESTMAN		=	$(DESTROOT)/share/man
+DESTETC         =       $(DESTDIR)/etc
 #<<need bitstring.h>>
 INCLUDE		=	-I.
 #INCLUDE	=
 #<<need getopt()>>
-LIBS		=
+LIBS		= $(PAM_LIBS) $(SELINUX_LIBS) $(AUDIT_LIBS)
 #<<optimize or debug?>>
-#OPTIM		=	-O
-OPTIM		=	-g
+OPTIM		=	-O2
+#OPTIM		=	-g
 #<<ATT or BSD or POSIX?>>
 # (ATT untested)
 #COMPAT		=	-DATT
 #(BSD is only needed if <sys/params.h> does not define it, as on ULTRIX)
 #COMPAT		=	-DBSD
 # (POSIX)
-#COMPAT		=	-DPOSIX
+COMPAT		=	-DPOSIX
 #<<lint flags of choice?>>
 LINTFLAGS	=	-hbxa $(INCLUDE) $(COMPAT) $(DEBUGGING)
 #<<want to use a nonstandard CC?>>
 #CC		=	vcc
 #<<manifest defines>>
-DEFS		=
+# Allow override from command line
+DEBUG_DEFS = -DDEBUGGING=0   
+# The -DUSE_SIGCHLD is needed for the Alpha port
+DEFS = -DDEBIAN -DUSE_SIGCHLD $(DEBUG_DEFS) $(PAM_DEFS) $(SELINUX_DEFS)
 #(SGI IRIX systems need this)
 #DEFS		=	-D_BSD_SIGNALS -Dconst=
 #<<the name of the BSD-like install program>>
 #INSTALL = installbsd
-INSTALL = install
+INSTALL = install -s
 #<<any special load flags>>
-LDFLAGS		=
+# LDFLAGS		=	-s
+# Let install do the strip
+
 #################################### end configurable stuff
 
 SHELL		=	/bin/sh
@@ -113,16 +119,23 @@
 			$(CC) $(LDFLAGS) -o crontab $(CRONTAB_OBJ) $(LIBS)
 
 install		:	all
-			$(INSTALL) -c -m  111 -o root -s cron    $(DESTSBIN)/
-			$(INSTALL) -c -m 4111 -o root -s crontab $(DESTBIN)/
+			$(INSTALL) -c -m  755 -o root cron    $(DESTSBIN)/
+			$(INSTALL) -c -m 4755 -o root crontab $(DESTBIN)/
+			cp etc/crontab $(DESTETC)/
 			sh putman.sh crontab.1 $(DESTMAN)
 			sh putman.sh cron.8    $(DESTMAN)
 			sh putman.sh crontab.5 $(DESTMAN)
 
-clean		:;	rm -f *.o cron crontab a.out core tags *~ #*
+clean		:
+			rm -f *.o cron crontab a.out core tags *~ #*
 
 kit		:	$(SHAR_SOURCE)
 			makekit -m -s99k $(SHAR_SOURCE)
-
+uninstall	:	
+			rm -f $(DESTSBIN)/cron
+			rm -f $(DESTBIN)/crontab
+			rm -f $(DESTETC)/init.d/cron
+			rm -f -R $(DESTETC)/cron.d $(DESTETC)/cron.daily $(DESTETC)/cron.weekly $(DESTETC)/cron.monthly
+			rm -f $(DESTMAN)/cron.8	 $(DESTMAN)/crontab.5 $(DESTMAN)/crontab.1
 $(CRON_OBJ)	:	cron.h compat.h config.h externs.h pathnames.h Makefile
 $(CRONTAB_OBJ)	:	cron.h compat.h config.h externs.h pathnames.h Makefile

=== debian/changelog ===
cron (3.0pl1-106) unstable; urgency=low

  * Install script has been fixed.

 -- Artem Buckhonov <nerzhulart@gmail.com>  Wed, 03 Nov 2010 20:19:50 +3000

=== debian/control ===
Source: cron
Section: automation
Priority: extra
Maintainer: Artem Bukhonov <nerzhulart@gmail.com>
Build-Depends: debhelper (>= 5)
Standards-Version: 3.7.2

Package: cron
Architecture: armel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: management of regular background processing
 cron is a background process (`daemon') that runs programs at regular intervals (for example, every minute, day, week or month); which processes are run and at what times are specified in the `crontab'. 
 Users may also install crontabs so that processes are run on their behalf, though this feature can be disabled or restricted to particular users. 
 Output from the commands is usually mailed to the system administrator (or to the user in question); you should probably install a mail system as well so that you can receive these messages. 
 This cron package is configured by default to do various standard system maintenance tasks, such as ensuring that logfiles do not grow endlessly and overflow the disk. 
 The lockfile-progs package is only a "Suggests" because of the poor way that dselect handles "Recommends", but I do strongly suggest that you install it; it prevents /etc/cron.daily/standard from running multiple times if something gets jammed.

## cron 3.0pl1-128ubuntu2+8.0trisquel1

=== debian/changelog ===
cron (3.0pl1-128ubuntu2+8.0trisquel1) flidas; urgency=medium

  * Removed non-free example #10868

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Mon, 27 Jun 2016 15:21:44 +0000

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# The package build supports three optional features. To enable/disable them,
# modify DEB_BUILD_OPTIONS accordingly:
#  * PAM support        default: ON     disable: DEB_BUILD_OPTIONS=nopam
#  * SELinux support    default: ON     disable: DEB_BUILD_OPTIONS=noselinux
#  * audit support      default: OFF    enable:  DEB_BUILD_OPTIONS=withaudit
#
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# Set system type (Linux, HURD, etc.)
DEB_HOST_ARCH_OS = $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

# Enable cross-compiling support
DEB_HOST_GNU_TYPE  = $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE = $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
export CC=$(DEB_HOST_GNU_TYPE)-gcc
endif

# Standard compiler flags 
CFLAGS += -Wall -Wno-unused -Wno-comment

# debug is disabled by default
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
  DEBUG_DEFS = -DDEBUGGING=1
else
  DEBUG_DEFS = -DDEBUGGING=0
endif
export DEBUG_DEFS

# PAM is enabled by default
ifeq (,$(findstring nopam,$(DEB_BUILD_OPTIONS)))
    PAM_DEFS = -DUSE_PAM
    PAM_LIBS = -lpam
    export PAM_DEFS PAM_LIBS
endif

# SELinux and audit are only available on Linux
ifeq ($(DEB_HOST_ARCH_OS), linux)
# SELinux is enabled by default
ifeq (,$(findstring noselinux,$(DEB_BUILD_OPTIONS)))
    SELINUX_DEFS = -DWITH_SELINUX
    SELINUX_LIBS = -lselinux
    export SELINUX_DEFS SELINUX_LIBS
endif

# audit is disabled by default
ifneq (,$(findstring withaudit,$(DEB_BUILD_OPTIONS)))
    AUDIT_DEFS = -DWITH_AUDIT
    AUDIT_LIBS = -laudit
    export AUDIT_DEFS AUDIT_LIBS
endif
endif # Linux


%:
	dh $@  --with=systemd


override_dh_auto_install:
	# Empty target to bypass the auto-detected install target in Makefile


override_dh_install:
	dh_install
	install -m 644 debian/crontab.main debian/cron/etc/crontab
	install -m 644 debian/placeholder debian/cron/etc/cron.d/.placeholder
	install -m 644 debian/placeholder debian/cron/etc/cron.hourly/.placeholder
	install -m 644 debian/placeholder debian/cron/etc/cron.daily/.placeholder
	install -m 644 debian/placeholder debian/cron/etc/cron.weekly/.placeholder
	install -m 644 debian/placeholder debian/cron/etc/cron.monthly/.placeholder


override_dh_installinit:
	dh_installinit -- start 89 2 3 4 5 . stop 11 1 .


override_dh_compress:
	dh_compress -Xexamples

## cron 3.0pl1-128.1ubuntu1+9.0trisquel1

=== Makefile ===
--- 
+++ 
@@ -51,7 +51,6 @@
 DESTSBIN	=	$(DESTROOT)/sbin
 DESTBIN		=	$(DESTROOT)/bin
 DESTMAN		=	$(DESTROOT)/share/man
-DESTETC         =       $(DESTDIR)/etc
 #<<need bitstring.h>>
 INCLUDE		=	-I.
 #INCLUDE	=
@@ -73,9 +72,9 @@
 #CC		=	vcc
 #<<manifest defines>>
 # Allow override from command line
-DEBUG_DEFS = -DDEBUGGING=0   
+DEBUG_DEFS  ?= -DDEBUGGING=0   
 # The -DUSE_SIGCHLD is needed for the Alpha port
-DEFS = -DDEBIAN -DUSE_SIGCHLD $(DEBUG_DEFS) $(PAM_DEFS) $(SELINUX_DEFS)
+DEFS = -DDEBIAN -DUSE_SIGCHLD $(DEBUG_DEFS) $(PAM_DEFS) $(SELINUX_DEFS) $(AUDIT_DEFS)
 #(SGI IRIX systems need this)
 #DEFS		=	-D_BSD_SIGNALS -Dconst=
 #<<the name of the BSD-like install program>>
@@ -88,7 +87,7 @@
 #################################### end configurable stuff
 
 SHELL		=	/bin/sh
-CFLAGS		=	$(OPTIM) $(INCLUDE) $(COMPAT) $(DEFS)
+CFLAGS		+=	$(INCLUDE) $(COMPAT) $(DEFS)
 
 INFOS		=	README CHANGES FEATURES INSTALL CONVERSION THANKS MAIL
 MANPAGES	=	bitstring.3 crontab.5 crontab.1 cron.8 putman.sh
@@ -121,7 +120,6 @@
 install		:	all
 			$(INSTALL) -c -m  755 -o root cron    $(DESTSBIN)/
 			$(INSTALL) -c -m 4755 -o root crontab $(DESTBIN)/
-			cp etc/crontab $(DESTETC)/
 			sh putman.sh crontab.1 $(DESTMAN)
 			sh putman.sh cron.8    $(DESTMAN)
 			sh putman.sh crontab.5 $(DESTMAN)
@@ -131,11 +129,6 @@
 
 kit		:	$(SHAR_SOURCE)
 			makekit -m -s99k $(SHAR_SOURCE)
-uninstall	:	
-			rm -f $(DESTSBIN)/cron
-			rm -f $(DESTBIN)/crontab
-			rm -f $(DESTETC)/init.d/cron
-			rm -f -R $(DESTETC)/cron.d $(DESTETC)/cron.daily $(DESTETC)/cron.weekly $(DESTETC)/cron.monthly
-			rm -f $(DESTMAN)/cron.8	 $(DESTMAN)/crontab.5 $(DESTMAN)/crontab.1
+
 $(CRON_OBJ)	:	cron.h compat.h config.h externs.h pathnames.h Makefile
 $(CRONTAB_OBJ)	:	cron.h compat.h config.h externs.h pathnames.h Makefile

=== debian/changelog ===
cron (3.0pl1-128.1ubuntu1+9.0trisquel1) etiona; urgency=medium

  * Removed non-free example #10868

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Fri, 01 Nov 2019 21:39:55 +0000

=== debian/control ===
Source: cron
Section: admin
Priority: important
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Maintainer: Javier Fernández-Sanguino Peña <jfs@debian.org>
Uploaders: Christian Kastner <debian@kvr.at>
Standards-Version: 3.9.6
Build-Depends:
    debhelper (>= 9),
    libpam0g-dev,
    libselinux1-dev [linux-any],
    libaudit-dev [linux-any],
    dh-systemd (>= 1.4)
Homepage: http://ftp.isc.org/isc/cron/
Vcs-Git: git://anonscm.debian.org/pkg-cron/pkg-cron.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-cron/pkg-cron.git

Package: cron
Architecture: any
Pre-Depends:
    dpkg (>= 1.15.7.2)
Depends:
    ${shlibs:Depends},
    ${misc:Depends},
    debianutils (>= 1.7),
    adduser,
    lsb-base (>= 3.0-10),
    libpam-runtime (>= 1.0.1-11)
Suggests:
    anacron (>=2.0-1),
    logrotate,
    checksecurity,
    exim4 | postfix | mail-transport-agent
Breaks:
    dpkg (<< 1.15.4)
Provides: cron-daemon
Description: process scheduling daemon
 The cron daemon is a background process that runs particular programs at
 particular times (for example, every minute, day, week, or month), as 
 specified in a crontab. By default, users may also create crontabs of
 their own so that processes are run on their behalf.
 .
 Output from the commands is usually mailed to the system administrator
 (or to the user in question); you should probably install a mail system
 as well so that you can receive these messages.
 .
 This cron package does not provide any system maintenance tasks. Basic
 periodic maintenance tasks are provided by other packages, such 
 as checksecurity.

=== debian/rules ===
--- 
+++ 
@@ -76,7 +76,7 @@
 
 
 override_dh_installinit:
-	dh_installinit -- start 89 2 3 4 5 . stop 11 1 .
+	dh_installinit -- start 89 2 3 4 5 .
 
 
 override_dh_compress:

=== debian/watch ===
version=3

http://ftp.isc.org/isc/cron/cron_(.*)\.shar

## cron 3.0pl1-128.1ubuntu1.1+9.0trisquel1

=== debian/changelog ===
cron (3.0pl1-128.1ubuntu1.1+9.0trisquel1) etiona-security; urgency=medium

  * Removed non-free example #10868

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Thu, 05 May 2022 14:36:13 +0000

cron (3.0pl1-128.1ubuntu1.1) bionic-security; urgency=medium

  * SECURITY UPDATE: privilege escalation in postinst script
    - Add sanity checks over the entries in spool directory and
      set up owner and group accordingly in debian/postinst
    - CVE-2017-9525
  * SECURITY UPDATE: denial of service via large file
    - Add sanity check in case of running out of memory when
      parsing the file in entry.c
    - CVE-2019-9704
  * SECURITY UPDATE: denial of service via large file
    - Add sanity check to ensure that no more than 1000 lines of
      length are allowed in crontabs in cron.h, crontab.c and
      user.c.
    - CVE-2019-9705
  * SECURITY UPDATE: denial of service by use-after-free
    - Add return values when there is no memory available
      in database.c
    - CVE-2019-9706

 -- David Fernandez Gonzalez <david.fernandezgonzalez@canonical.com>  Fri, 29 Apr 2022 11:16:53 +0200

## cron 3.0pl1-128.1ubuntu1.2+9.0trisquel1

=== debian/changelog ===
cron (3.0pl1-128.1ubuntu1.2+9.0trisquel1) etiona-security; urgency=medium

  * Removed non-free example #10868

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Wed, 11 May 2022 00:35:56 +0000

cron (3.0pl1-128.1ubuntu1.2) bionic-security; urgency=medium

  * SECURITY REGRESSION: CVE-2017-9525 regression (LP: #1971895)
    - debian/postinst: add tab_name emptiness check
    - https://salsa.debian.org/debian/cron/-/commit/23047851

 -- Rodrigo Figueiredo Zaiden <rodrigo.zaiden@canonical.com>  Tue, 10 May 2022 17:59:19 -0300

## cron 3.0pl1-133-cl4.3.1u4

=== debian/changelog ===
cron (3.0pl1-133-cl4.3.1u4) RELEASED; urgency=medium

  * new build for 4.3.1 from original hash
    df1e428bde5bc8cff157b7ea337cc283a01068de

 -- root <root@7490f848894d>  Tue, 14 Jun 2022 07:54:44 +0000

cron (3.0pl1-133-cl4u1) RELEASED; urgency=medium

   * First 4.0 release; merged up to buster pl1-133 level

 -- dev-support <dev-support@cumulusnetworks.com>  Wed, 03 Apr 2019 15:50:05 -0700

cron (3.0pl1-cl3u1) RELEASED; urgency=medium
  * New Enabled: cron will now log output to syslog if no mail transfer agent
  * [ Josh Triplett ] - from the 4 patches in
      https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=670118
  * Add two new log levels: -L 16 logs all cron job output, and -L 32 logs all
    cron job output when not already mailing that output.
  * In /etc/default/cron, change the default log level to -L 38 for Cumulus,
    to ensure that cron job output gets logged on systems without an MTA

 -- dev-support <dev-support@cumulusnetworks.com>  Tue, 29 Mar 2016 15:56:37 -0700

=== debian/control ===
Source: cron
Section: admin
Priority: important
Maintainer: dev-support <dev-support@cumulusnetworks.com>
Standards-Version: 4.3.0
Build-Depends:
    debhelper-compat (= 12),
    libpam0g-dev,
    libselinux1-dev [linux-any],
    libaudit-dev [linux-any],
    dh-systemd (>= 1.4), git
Homepage: https://ftp.isc.org/isc/cron/
Rules-Requires-Root: no
XS-Build-Source: True
XS-Cumulus-Valid-Arch: amd64 armel
XBCS-Vcs-Hash: df1e428bde5bc8cff157b7ea337cc283a01068de

Package: cron
Architecture: any
Multi-Arch: foreign
Pre-Depends:
    ${misc:Pre-Depends},
Depends:
    ${shlibs:Depends},
    ${misc:Depends},
    debianutils (>= 1.7),
    sensible-utils,
    adduser,
    lsb-base (>= 3.0-10),
    libpam-runtime (>= 1.0.1-11)
Recommends:
    rsyslog | system-log-daemon
Suggests:
    anacron (>= 2.0-1),
    logrotate,
    checksecurity,
    default-mta | mail-transport-agent
Provides: cron-daemon
Description: process scheduling daemon
 The cron daemon is a background process that runs particular programs at
 particular times (for example, every minute, day, week, or month), as
 specified in a crontab. By default, users may also create crontabs of
 their own so that processes are run on their behalf.
 .
 Output from cron jobs is either mailed to the user or logged to the system
 log.  You should install a syslog daemon if you want to log cron job output, or
 install a mail transport agent if you want to receive cron job output by email.
 .
 This cron package does not provide any system maintenance tasks. Basic
 periodic maintenance tasks are provided by other packages, such
 as checksecurity.
XBCS-Vcs-Hash: df1e428bde5bc8cff157b7ea337cc283a01068de

=== debian/rules ===
--- 
+++ 
@@ -10,19 +10,17 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-
-# Set system type (Linux, HURD, etc.)
-DEB_HOST_ARCH_OS = $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
+# Retrieve architecture-related variables
+include /usr/share/dpkg/architecture.mk
 
 # Enable cross-compiling support
-DEB_HOST_GNU_TYPE  = $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
-DEB_BUILD_GNU_TYPE = $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
 ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
 export CC=$(DEB_HOST_GNU_TYPE)-gcc
 endif
 
-# Standard compiler flags 
-CFLAGS += -Wall -Wno-unused -Wno-comment
+# Customize build flags
+export DEB_CFLAGS_MAINT_APPEND += -Wall -Wno-unused -Wno-comment
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 # debug is disabled by default
 ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
@@ -58,7 +56,7 @@
 
 
 %:
-	dh $@  --with=systemd
+	dh $@
 
 
 override_dh_auto_install:
@@ -75,9 +73,5 @@
 	install -m 644 debian/placeholder debian/cron/etc/cron.monthly/.placeholder
 
 
-override_dh_installinit:
-	dh_installinit -- start 89 2 3 4 5 .
-
-
 override_dh_compress:
 	dh_compress -Xexamples
